/*+~><>~~~~~~~~~~~~~~~~~~~~~~><>~~~~~~~~~~~~~~~~~~~~~~><>~~~~~~~~~~~~~~~~~~~~~~+
  |                                                                            |
  |                                    Copyright  2006, Accrete LLC           |
  |                                          http://www.accrete.com            |
  | For further information on the Accrete Trading Model",                     |
  | visit the web at www.accrete.com/fx-atm . There you will find various      |
  | links, trade examples, and the latest updates on the model by Accrete      | 
  |                                                                            |
  | The original code was modified to illustrate the addition of speech.       |
  | The two modules ( gSpeak.mqh and speak.dll ) needed to add speech to MT4   |
  | were written by Codersguru.   http://www.metatrader.info/node/85           |
  |   ++ modified by hapalkos 2007.01.22                                       |
  +~><>~~~~~~~~~~~~~~~~~~~~~~><>~~~~~~~~~~~~~~~~~~~~~~><>~~~~~~~~~~~~~~~~~~~~~~+
*/
#property copyright "raff1410@o2.pl"

#property indicator_chart_window

#include <gSpeak.mqh>      // NOTE 1 ...  Reference to gSpeak.mqh which must be installed in the "include" directory.
                           // NOTE 1 ...  The operating system module, speak.dll, must also be installed in the "library" directory.
                           // NOTE 1 ...  These two modules access the currently selected text-to-speech engine of your computer. 
                                               
extern string TLineName="TrendLineRisingAlert";
extern color LineColor=Red; 
extern int LineStyle=STYLE_SOLID;
extern int AlertPipRange=2; 
extern string AlertWav="rising-price-alert.wav";      
extern bool EmailON=false;

string FinSym;             // NOTE 2 ...  addition of FinSym (Financial Symbol) to facilitate the use of Symbol() for speech.

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
      ObjectCreate(TLineName, OBJ_TREND, 0, Time[25], Bid, Time[0], Ask);
      ObjectSet(TLineName, OBJPROP_STYLE, LineStyle);
      ObjectSet(TLineName, OBJPROP_COLOR, LineColor);
      
      if (Symbol() == "GBPUSD") FinSym = "Kay bull";        // NOTE 3 ...  Provides pronunciation for the Symbol() of the chart. 
      if (Symbol() == "EURUSD") FinSym = "euro dollar";     // NOTE 3 ...  Spelling may need to be altered to achieve correct pronunciation with your speech engine.
      if (Symbol() == "AUDUSD") FinSym = "aussie dollar";   // NOTE 3 ...  Additional pairs can be added in the same manner.
      if (Symbol() == "USDJPY") FinSym = "doll are yen";
      if (Symbol() == "USDCAD") FinSym = "loonie";
      if (Symbol() == "USDCHF") FinSym = "swissie";      
           
      string CurrentPrice = DoubleToStr(Bid, Digits);    // NOTE 4 ...  CurrentPrice using the DoubleToStr command to limit the number of spoken digits.

      double val=ObjectGetValueByShift(TLineName, 0);
      if (Bid-AlertPipRange*Point <= val && Bid+AlertPipRange*Point >= val) gSpeak(" Rising Price Alert! " + FinSym + " is rising!" + CurrentPrice);
      
                                                         // NOTE 5 ...  The PlaySound function can be replaced by the gSpeak command.
                                                         // NOTE 5 ...  I tried using PlaySound and gSpeak together. It works fine if there is only one indicator with this configuration.
                                                         // NOTE 5 ...  Running several indicators with PlaySound and gSpeak paired together results in a very slow system.
                                                         // NOTE 5 ...  Therefore it is better to replace the PlaySound function with the gSpeak function.
                                                         // NOTE 5 ...  Text, string and numerical variables can be concantenated to provide very specific audio alerts.
                                                         // NOTE 5 ...  Due to the vagaries of my speech engine the first "falling" is pronounced differently than the second.
                                                         // NOTE 5 ...  Therefore the spelling of the first "falling" is altered for phonetic pronunciation. "Rising" does not have this problem.
                                                         // NOTE 5 ...  My speech engine announces CurrentPrice in the following manner: "one point eight seven eight one."
                                                         // NOTE 5 ...  Other text-to-speech engines my say the number in a different manner.
                                                         // NOTE 5 ...  I have included exclamation points because my speech engine uses them to change the emphasis on words.
                                                         // NOTE 5 ...  Other engines my say "exclamation point" for which you would want to remove them.
                                                         
      if (EmailON) SendMail("FX Currency Rising Price Alert","FX Currency Rising Price Alert");

//----
//----
   return(0);
  }
//+------------------------------------------------------------------+